var mysql = require("./db-mysql");

/*
new mysql.Database({
    hostname: 'localhost',
    user: 'root',
    password: 'password',
    database: 'node'
}).connect(function(err) {
    if (err) {
        return console.log('CONNECTION error: ' + err);
    }

    var error, result;

    this.query({ async: false }).
        update('users').
        set({ name: 'Lorna Doe' }).
        where('id = ?', [ 9999 ]).
        execute(function(err, res) {
            if (err) {
                error = err;
            } else {
                result = res;
            }
        });

    if (error) {
        console.log('QUERY ERROR: ' + error);
    } else {
        console.log('RESULT: ');
        console.log(result);
    }
});
*/

var db = new mysql.Database({
    hostname: 'localhost',
    user: 'root',
    password: 'password',
    database: 'node'
});

db.connect({ async: false });
if (!db.isConnected()) {
    return console.log("NOT CONNECTED");
}

var error, result;

db.query().
    update('users').
    set({ name: 'Lorna Doe' }).
    where('id = ?', [ 9999 ]).
    execute(function(err, res) {
        if (err) {
            error = err;
        } else {
            result = res;
        }
    }, { async: false });

if (error) {
    console.log('QUERY ERROR: ' + error);
} else {
    console.log('RESULT: ');
    console.log(result);
}

db.disconnect();
