var mysql = require("./db-mysql");

var selectStart = new Date();
var settings = {
    hostname: "localhost",
    user: "root",
    password: "password",
    database: "node"
};

console.log("BEFORE SYNC CONNECT");
new mysql.Database(settings).on("error", function(error) {
    console.log("ERROR: " + error);
}).on("ready", function(server) {
    console.log("[S] Connected to " + server.hostname + " (" + server.version + ")");

    console.log("BEFORE SYNC QUERY");
    query = this.query("SELECT * FROM users", {
        start: function(query) {
            console.log("[S] " + query);
        },
        finish: function() {
            console.log("[S] " + (new Date() - selectStart) + " ms.");
        }
    }).execute(function(error, rows, columns) {
        if (error) {
            console.log("[S] QUERY ERROR: " + error);
            return;
        }
        console.log("[S] Columns:");
        console.log(columns);
        if (rows) {
            console.log("[S] First row:");
            console.log(rows[0]);
            console.log("[S] " + rows.length + " TOTAL ROWS");
        }
    });
    console.log("AFTER SYNC QUERY");
}).connect({ async: false });
console.log("AFTER SYNC CONNECT");

